public class ListaDinamica {
	NoLista inicio;

	public ListaDinamica() 
	{
		this.inicio = null;
	} 
   
   
    public void insereOrdenado(Funcionario novoFuncionario)
	{
		NoLista novoNo = new NoLista(novoFuncionario);
		
		NoLista ant = null; 
		NoLista p = this.inicio; 

		while (p != null && p.info.id < novoFuncionario.id) 
		{
			ant = p;
			p = p.proximo;
		}
		
		if (ant == null) 
		{ 
			novoNo.proximo = this.inicio;
			this.inicio = novoNo;
		} 
		
		else 
		{ 
			novoNo.proximo = p;
			ant.proximo = novoNo;
		}   
	}

    // insere valor no começo da lista
	public void inserirNoInicio(Funcionario valor) 
	{
		if (this.inicio == null) 
		{
			// lista vazia, então só é preciso criar o nó
			this.inicio = new NoLista(valor);
		} 
		
		else 
		{
            // cria-se novo no e atualiza o NoLista inicio 
			NoLista novoNo = new NoLista(valor);
			
			novoNo.proximo = this.inicio;
			
			this.inicio = novoNo;
		}
			
	} 
   
    // insere valor no fim da lista	  
    public void inserirNoFim(Funcionario valor) 
	{
		if (this.inicio == null) 
		{
			// lista vazia
			this.inicio = new NoLista(valor);
		} 
		
		else 
		{
			// procura pelo fim da lista
			NoLista atual = this.inicio;

			while (atual.proximo != null) 
			{
				atual = atual.proximo;
			}
			
			// insere o nó no fim da lista
			atual.proximo = new NoLista(valor);
		}
			
	}  
	
	public void retira(Funcionario demitido) //Em qualquer posicao
	{
    
		NoLista ant = null; 
		NoLista p = this.inicio;     
		 
		while (p != null && p.info.id != demitido.id) {
		   ant = p;
		   p = p.proximo;
		}
		
		if (p != null)
		{
			if (ant == null) 
			{
			   this.inicio = p.proximo;
			}
	  
			else 
			{
			   ant.proximo = p.proximo;
			}
		}
	}
	
	public NoLista busca(Funcionario v)
	{
	    int i=0;
		
	    for (NoLista p = this.inicio; p!=null; p = p.proximo)
		{
			if(p.info == v)
			{
			   System.out.println("\n\nachou na posicao: " + i + "\n\n");
			   return p;
			}
			i++;
		}
		
		return null;
	}
	
	public void imprime()
	{
		for(NoLista q=this.inicio;q!=null; q=q.proximo)
		{
			System.out.println("\n\nId: " + q.info.id +
					"\nNome: " + q.info.nome +
					"\nSobrenome: " + q.info.sobrenome +
					"\nCPF: " + q.info.cpf +
					"\nIdade: " + q.info.idade +
					"\nSexo: " + q.info.sexo +
					"\nRG: " + q.info.rg);
			
			System.out.println();
		}
		
		System.out.println();

	}
	
	public void removaFim()
	{
		NoLista ant = null;
		NoLista p = inicio;
		
		while(p.proximo != null)		
		{
			ant = p;
			p = p.proximo;
		}
		
		if(ant == null)
		{
			inicio = null;
		}
		
		else
		{
			ant.proximo = null;
		}
		
	}

}
